Protocol Documentation

Table of Contents

common.proto

Top

ClientId

Identifier for client. Used in subscribe and publish. Subscriptions will not

receive updates from publish calls with the same ClientId.

FieldTypeLabelDescription
id string

Identifier as string

E2e

Information about E2E configuration.

FieldTypeLabelDescription
profile E2eProfile

Profile.

dataId uint32

Data ID for CRC calculation.

signalCrc string

Name of signal for CRC field.

signalCounter string

Name of signal for counter field.

Empty

Symbolic message representing no argument needed or provided.

FrameInfo

Information about a frame and it's signals.

FieldTypeLabelDescription
signalInfo SignalInfo

Information about the frame itself.

childInfo SignalInfo repeated

Information about signals included in frame.

Frames

Collection of information for several frames.

FieldTypeLabelDescription
frame FrameInfo repeated

List of information about frames.

Group

Group inside of frame.

FieldTypeLabelDescription
start uint32

Byte offset in frame for group.

length uint32

Byte length of group.

e2e E2e

E2E property for group.

MetaData

Collection of all meta data for a signal.

RemotiveBroker support several databases. The following attributes are read

from the database running on the RemotiveBroker.

FieldTypeLabelDescription
description string

Description for signal.

max float

Maximum allowed value.

min float

Minimum allowed value.

unit string

Unit of the signal value.

size int32

Size of signal value when packed in frame.

isRaw bool

Is binary data?

factor double

Multiplication faction used for encoding and decoding value in frame.

offset double

Offset used for encoding and decoding value in frame.

sender string repeated

List of named senders of signals.

receiver string repeated

List of named receivers of signal.

cycleTime float

Cadence for sending signal in milliseconds.

startValue float

Initial value to use before publishing.

multiplex Multiplex

Frame multiplexing information.

e2e E2e

E2e information about frame.

groups Group repeated

Groups inside frame.

frameId uint32

Associated identification number for frame.

namedValues MetaData.NamedValuesEntry repeated

Key-value dictionary of named values.

startBit int32

Signal start bit in frame

MetaData.NamedValuesEntry

FieldTypeLabelDescription
key int64

value string

Multiplex

Multiplexing information.

Some signal databases allow "multiplexing" or "unions" in their frame

information. IF a signal is in `select` mode, the value of the signal will

act as a filter for signals which are in `filter` mode.

FieldTypeLabelDescription
none Empty

select Empty

filter int32

NameSpace

Identifier for a name space.

FieldTypeLabelDescription
name string

Name of name space, which in turn is typically redirected in interfaces.json to an electrical interface.

Namespaces

FieldTypeLabelDescription
items NameSpace repeated

NetworkInfo

Information about network

FieldTypeLabelDescription
namespace NameSpace

Corresponding name space.

type string

Type of network as text. Eg "can", "lin" etc.

description string

Description text about network.

SignalId

Identifier for a signal.

FieldTypeLabelDescription
name string

Name of signal.

namespace NameSpace

Which name space signal belongs in.

SignalInfo

Information about a signal. Including name and all meta data fields.

FieldTypeLabelDescription
id SignalId

metaData MetaData

StreamError

Response message for bidirectional streaming RPCs. Error is set when a request fails.

FieldTypeLabelDescription
error string

E2eProfile

Supported E2E profiles.

NameNumberDescription
PROFILE_AR_01A 0

Autosar 1A Both

PROFILE_AR_01B 1

Autosar 1B Alternating

PROFILE_AR_01C 2

Autosar 1 Nibble

PROFILE_AR_01Low 3

Autosar 1 Low

PROFILE_AR_05 4

Autosar 5

PROFILE_AR_02 5

Autosar 2

system_api.proto

Top

BatchDownloadFileChunksRequest

FieldTypeLabelDescription
fileDescriptions FileDescription repeated

timeout uint32

Server-side timeout (in milliseconds) for downloading a chunk. The timeout is for each chunk, not the entire file. If the timeout is exceeded, the server will cancel the download and return an error.

BatchDownloadFileChunksResponse

FieldTypeLabelDescription
lastChunk bool

Amount of chunks.

chunkId uint32

Index of this chunk. Start with 0.

chunk bytes

Chunk data.

estimatedTotalSize uint32

Estimated total size in bytes.

Configuration

Configuration of server.

FieldTypeLabelDescription
networkInfo NetworkInfo repeated

Network information.

interfacesJson bytes

Server configuration file `interfaces.json`.

publicAddress string

IP address of server.

serverVersion string

Version of RemotiveBroker.

interfacesInfo string

Contains configuration file deprecation warnings, validation errors and similar

remotiveConfigDir string

Directory for shared RemotiveLabs configuration including authentication

brokerConfigId string

Identifier for configuration file `interfaces.json`

topologyInstanceId string

Identifier for topology instance that was used to generate the configuration for this RemotiveBroker

topologyGenerateId string

Identifier for when the topology instance was generated

FileDescription

File information.

FieldTypeLabelDescription
sha256 string

File checksum.

path string

File (path and filename) on server.

FileDescriptions

FieldTypeLabelDescription
fileDescriptions FileDescription repeated

FileDownloadResponse

Response from file download request.

FieldTypeLabelDescription
chunk bytes

File content.

errorMessage string

Error with reason.

FileUploadChunkRequest

Request for file chunk upload.

Divide file in chunks of n bytes, where recommend n is 500000 bytes.

SHA256 which is part of FileDescription only needs to be submitted in the

last chunk.

FieldTypeLabelDescription
fileDescription FileDescription

What file this chunk is for.

chunks uint32

Amount of chunks.

chunkId uint32

Index of this chunk. Start with 0.

chunk bytes

Chunk data.

cancelUpload bool

Cancel upload request.

uploadTimeout uint32

Server side timeout (ms) for uploading all chunks which represents full file.

FileUploadRequest

Parameters for a file upload.

SHA256 which is part of FileDescription only needs to be submitted in the

last chunk.

FieldTypeLabelDescription
fileDescription FileDescription

Information about file to upload.

chunk bytes

Amount of chunks that will be sent for this file.

FileUploadResponse

Response from file or file chunk upload.

FieldTypeLabelDescription
finished bool

Upload completed.

cancelled bool

Upload canceled.

errorMessage string

Error with reason.

FrontendSettingsRequest

FieldTypeLabelDescription
v1 FrontendSettingsRequestV1

FrontendSettingsRequestV1

FieldTypeLabelDescription
data string

FrontendSettingsResponse

FieldTypeLabelDescription
v1 FrontendSettingsResponseV1

FrontendSettingsResponseV1

FieldTypeLabelDescription
data string

License

License data.

FieldTypeLabelDescription
data bytes

Content of license.

termsAgreement bool

Check if user accepted user agreement.

LicenseInfo

Server license information.

FieldTypeLabelDescription
status LicenseStatus

Status of license.

json bytes

Verbatim json from the license data if BASE64-decodable.

expires string

Extracted from json for convenience.

requestId string

Info to use when requesting a new license.

requestMachineId bytes

Identifier for machine running server.

LinScheduleSwitch

Request to switch the active schedule for a LIN master namespace

FieldTypeLabelDescription
namespace NameSpace

LIN namespace to switch schedule for

schedule_table_name string

Name of the schedule table to activate

PropertyValue

FieldTypeLabelDescription
name string

Example name: "secoc_key", "secoc_fv"

scope string repeated

Example input: [<namespace>, <keyId>] or [<namespace>, <profile>]

raw bytes

integer int64

double double

ReloadMessage

Response from reload request.

FieldTypeLabelDescription
configuration Configuration

New configuration from successfully reload operation.

errorMessage string

Response from failed reload operation.

LicenseStatus

Type for license status.

NameNumberDescription
UNSET 0

No license.

VALID 1

Valid license.

EXPIRED 2

Expired.

BADDATE 3

Error, incorrect date.

WRONGMACHINE 4

Error, license not for this machine.

INCOMPLETEJSON 5

Error, Incomplete license file.

INVALIDJSON 6

Error, Incomplete license json file.

BADSIGNATURE 7

Error, Bad signature on license file.

MALFORMED 8

Error, reading license file.

SERVERERROR 9

Error, server side.

NOTERMSAGREEMENT 10

Error, user has not accepted terms.

SystemService

Handle configuration of the RemotiveBroker server.

Method NameRequest TypeResponse TypeDescription
GetConfiguration Empty Configuration

Get current configuration of server.

ListSignals NameSpace Frames

Get list of all available frames and signals on server.

HealthCheck Empty Empty

Check if broker is running and ready to serve

UploadFileChunk FileUploadChunkRequest FileUploadResponse

Upload file using chunks (without streams), specifically useful for gRPC-web which does not support Client-side streaming.

UploadFile FileUploadRequest stream FileUploadResponse

Upload file using streams, preferred option for client with Client-side streaming.

BatchDeleteFiles FileDescriptions Empty

Delete a single or multiple files from server.

BatchDownloadFiles FileDescriptions FileDownloadResponse stream

Download a single or multiple files from server.

BatchDownloadFileChunks BatchDownloadFileChunksRequest BatchDownloadFileChunksResponse

ReloadConfiguration Empty ReloadMessage

Will not return until new configuration is tested an active, make sure to set timeout to a large value. (fibex on pi > 50s).

GetLicenseInfo Empty LicenseInfo

Get information about server license.

GetFrontendSettings FrontendSettingsRequest FrontendSettingsResponse

SetLicense License LicenseInfo

Set server license.

SetProperty PropertyValue Empty

Sets a custom property, such as SecOc parameters

SwitchLinSchedule LinScheduleSwitch Empty

Switch the active schedule for a LIN master namespace

Methods with HTTP bindings

Method Name Method Pattern Body
GetConfiguration POST /v1/GetConfiguration/ *
ListSignals POST /v1/ListSignals/ *
HealthCheck GET / *
UploadFileChunk POST /v1/UploadFileChunk/ *
UploadFile POST /v1/UploadFile/ *
BatchDeleteFiles POST /v1/BatchDeleteFiles/ *
BatchDownloadFiles POST /v1/BatchDownloadFiles/ *
BatchDownloadFileChunks POST /v1/BatchDownloadFileChunks/ *
ReloadConfiguration POST /v1/ReloadConfiguration/ *
GetLicenseInfo POST /v1/GetLicenseInfo/ *
GetFrontendSettings POST /v1/GetFrontendSettings/ *
SetLicense POST /v1/SetLicense/ *
SetProperty POST /v1/SetProperty/ *
SwitchLinSchedule POST /v1/SwitchLinSchedule/ *

network_api.proto

Top

CountByFrameId

FieldTypeLabelDescription
frameId uint32

count uint64

FramesDistribution

FieldTypeLabelDescription
countsByFrameId CountByFrameId repeated

FramesDistributionConfig

FieldTypeLabelDescription
namespace NameSpace

Name of the namespace from which we wish to subscribe to frames distributions.

PublisherConfig

Parameters for publishing values.

FieldTypeLabelDescription
signals Signals

Signals with values.

clientId ClientId

frequency int32

Specify frequency of publication. Specify 0 to only publish once.

Signal

Signal with value.

FieldTypeLabelDescription
id SignalId

Identifier of signal to publish.

integer int64

Value with integer type (int64).

double double

Floating point data type (double).

arbitration bool

Exclusive for LIN bus, present as true when a header is presented on the bus.

empty bool

No data supplied.

strValue string

(Supports publishing signals with named values or raw signals. / - If the signal has named values, the provided value must exactly match a defined name (case-sensitive). / - For raw signals, the provided value can be any string.)

uinteger64 uint64

Unsigned 64-bit integer value.

raw bytes

Binary data of value, relevant for Frames.

timestamp int64

time stamp in micro seconds, set when first seen.

SignalIds

List of signal identifiers

FieldTypeLabelDescription
signalId SignalId repeated

List of signal identifiers.

Signals

Signals with values

FieldTypeLabelDescription
signal Signal repeated

List of signals with values.

SubscriberConfig

Parameters for subscription.

FieldTypeLabelDescription
clientId ClientId

Identifier of subscriber, typically your app identifier. Published signals with same identifier will not trigger callback.

signals SignalIds

List of signals in subscription.

onChange bool

Only trigger callback when value changes when set to true.

initialEmpty bool

Will trigger an initial empty response once the subscription is ready

SubscriberWithScriptConfig

FieldTypeLabelDescription
clientId ClientId

Identifier of subscriber, typically your app identifier. Published signals with same identifier will not trigger callback.

script bytes

Custom Lua mapping code

onChange bool

Only trigger callback when value changes when set to true.

Value

FieldTypeLabelDescription
integer int64

raw bytes

double double

strValue string

uinteger64 uint64

NetworkService

Signal publish, subscribe and read.

Method NameRequest TypeResponse TypeDescription
SubscribeToSignals SubscriberConfig Signals stream

Subscribe to signals.

SubscribeToSignalWithScript SubscriberWithScriptConfig Signals stream

Subscribe to signals with transform provided as a LUA script.

SubscribeToFramesDistribution FramesDistributionConfig FramesDistribution stream

A stream which emits frames distributions of a provided namespace. Useful for diagnostic purposes. Counts are reset every 500 ms.

PublishSignals PublisherConfig Empty

Publish signals with values.

PublishSignalsStream PublisherConfig stream StreamError stream

Bidirectional streaming publish.

ReadSignals SignalIds Signals

Read signals from cache.

Methods with HTTP bindings

Method Name Method Pattern Body
SubscribeToSignals POST /v1/SubscribeToSignals/ *
SubscribeToSignalWithScript POST /v1/SubscribeToSignalWithScript/ *
SubscribeToFramesDistribution POST /v1/SubscribeToFramesDistribution/ *
PublishSignals POST /v1/PublishSignals/ *
PublishSignalsStream POST /v1/PublishSignalsStream/ *

restbus_api.proto

Top

AddRequest

FieldTypeLabelDescription
clientId ClientId

clientId will be used by the Restbus when as source of the outgoing signals

startOption StartOption

startOption affects all frames in the namespace

frames FrameConfigs

defaultSignals SignalSequence repeated

FrameConfig

FieldTypeLabelDescription
frameId SignalId

cycleTime float

The cycle time of the frame in milliseconds. Setting cycle time 0 will make the broker use the default cycle time of the frame Cycle time must be greater than 0, otherwise the frame is ignored by the Restbus

FrameConfigs

FieldTypeLabelDescription
items FrameConfig repeated

RemoveRequest

FieldTypeLabelDescription
namespaces Namespaces

frameIds SignalIds

ResetRequest

FieldTypeLabelDescription
namespaces Namespaces

frameIds SignalIds

signalIds SignalIds

RestbusRequest

FieldTypeLabelDescription
namespaces Namespaces

SignalSequence

FieldTypeLabelDescription
id SignalId

loop Value repeated

The loop to be emitted in the sequence.

initial Value repeated

The initial values to be emitted before the loop is iterated.

UpdateRequest

FieldTypeLabelDescription
signals SignalSequence repeated

StartOption

NameNumberDescription
START_AFTER_ADD 0

Will start the restbus if it is not already started

NOP 1

Will keep the current state of the restbus

RestbusService

Method NameRequest TypeResponse TypeDescription
Add AddRequest Empty

Add starts the Restbus if the startOption is START_AFTER_ADD. Add removes any previous configuration before applying the new one.

Remove RemoveRequest Empty

Remove

Update UpdateRequest Empty

Update updates the values of signals configured in the Restbus. The values are updated and the Restbus will emit the new values at the next cycle after the update.

UpdateStream UpdateRequest stream StreamError stream

UpdateStream is a bidirectional streaming version of Update.

Start RestbusRequest Empty

Start starts the Restbus

Stop RestbusRequest Empty

Stop stops the Restbus

Reset ResetRequest Empty

Reset resets signals configured in the Restbus or the whole Restbus depending on the request. Signals are reset to their default values as configured by the Configure request.

Methods with HTTP bindings

Method Name Method Pattern Body
Add POST /v1/Restbus/Add/ *
Remove POST /v1/Restbus/Remove/ *
Update POST /v1/Restbus/Update/ *
UpdateStream POST /v1/Restbus/UpdateStream/ *
Start POST /v1/Restbus/Start/ *
Stop POST /v1/Restbus/Stop/ *
Reset POST /v1/Restbus/Reset/ *

traffic_api.proto

Top

PlaybackConfig

Information about name space and file associated with playback or recording.

Playback will play signals on namespace. Recordings will record all signals

on name space.

FieldTypeLabelDescription
fileDescription FileDescription

File information.

namespace NameSpace

Name space associated.

PlaybackInfo

Information about a playback or a recording.

FieldTypeLabelDescription
playbackConfig PlaybackConfig

File and name space information.

playbackMode PlaybackMode

Current mode.

PlaybackInfos

Information about all playbacks and recordings.

FieldTypeLabelDescription
playbackInfo PlaybackInfo repeated

List of all information.

PlaybackMode

Status of playback.

FieldTypeLabelDescription
errorMessage string

Error reason.

EOF string

End of file; playback finished

mode Mode

Active with mode.

offsetTime uint64

Current offset in micro seconds.

startTime uint64

Start time in monotonic micro seconds.

endTime uint64

End time in monotonic micro seconds.

timeDeviation int64

Time deviation in micro seconds, measured by server.

offsetWallClockVsSample int64

Signal and wall clock offset. Signals might have a seperate timestamp.

noPlaybackToApplication bool

Allows disabling of data flow from recording to application layers. Default is set to false.

playbackToBus bool

Let data to be replayed to the bus specified in intefaces.json. Defalt set to false.

Mode

Modes of playback and recording.

NameNumberDescription
PLAY 0

Playing a file.

PAUSE 1

Playback is paused.

STOP 2

Playback in stopped and will be played from beginning when restarted.

RECORD 3

Recording a playback.

SEEK 4

Seek to offset in a playback.

CLOSE 5

Close the recording session.

TrafficService

Handle playback and recordings.

Method NameRequest TypeResponse TypeDescription
PlayTraffic PlaybackInfos PlaybackInfos

Play a playback or start recording.

PlayTrafficStatus Empty PlaybackInfos stream

Get continuous status of playback states.

Methods with HTTP bindings

Method Name Method Pattern Body
PlayTraffic POST /v1/PlayTraffic/ *
PlayTrafficStatus POST /v1/PlayTrafficStatus/ *

recordingsession_api.proto

Top

ChannelToNamespace

FieldTypeLabelDescription
channel string

Channel name.

namespace string

The namespace to use for channel.

File

Information about a file.

FieldTypeLabelDescription
path string

File information.

type FileType

Type of file.

createdTime uint64

Creation time in seconds since epoch.

modifiedTime uint64

Modification time in seconds since epoch.

size uint64

Size of file in bytes.

FileListingRequest

File listing request.

FieldTypeLabelDescription
path string

Path to list files from, empty for root.

types FileType repeated

Type of file.

FileListingResponse

File listing response.

FieldTypeLabelDescription
files File repeated

List of files.

PlaybackRepeat

FieldTypeLabelDescription
startOffset uint64

At which offset (in micro seconds) repeat should start.

endOffset uint64

At which offset (in micro seconds) repeat should go back to starting offset.

RecordingSessionCloseCommand

FieldTypeLabelDescription
path string

File information.

RecordingSessionOpenCommand

FieldTypeLabelDescription
path string

File information.

mappings ChannelToNamespace repeated

Optional channel to namespace mappings to override default behavior.

force bool

Will close any opened session for the same path and open a new one.

RecordingSessionPauseCommand

FieldTypeLabelDescription
path string

File information.

offset uint64 optional

Optional offset in micro seconds.

RecordingSessionPlayCommand

FieldTypeLabelDescription
path string

File information.

offset uint64 optional

Optional offset in micro seconds.

RecordingSessionPlaybackStatus

FieldTypeLabelDescription
path string

File information.

mode RecordingSessionPlaybackMode

Current playback mode.

offset uint64

Current offset in micro seconds.

repeat PlaybackRepeat

Current repeat information (optional).

RecordingSessionPlaybackStatuses

FieldTypeLabelDescription
items RecordingSessionPlaybackStatus repeated

RecordingSessionRepeatCommand

FieldTypeLabelDescription
path string

File information.

startOffset uint64 optional

At which offset (in micro seconds) repeat should start. Omit to start at the beginning of the file.

endOffset uint64 optional

At which offset (in micro seconds) repeat should go back to starting offset. Omit to repeat until the end of the file.

RecordingSessionSeekCommand

FieldTypeLabelDescription
path string

File information.

offset uint64

Offset in micro seconds.

FileType

File types supported by RemotiveBroker.

NameNumberDescription
FILE_TYPE_UNKNOWN 0

Unknown file.

FILE_TYPE_FOLDER 1

Folder.

FILE_TYPE_VIDEO 2

Video file.

FILE_TYPE_AUDIO 3

Audio file.

FILE_TYPE_IMAGE 4

Image file.

FILE_TYPE_RECORDING 5

Recording file (candump, blf, mdf, ...).

FILE_TYPE_RECORDING_SESSION 6

Recording session file (.recording.yaml).

FILE_TYPE_RECORDING_MAPPING 7

Recording mapping file (.mapping.yaml).

FILE_TYPE_PLATFORM 8

Topology platform file (.platform.yaml).

FILE_TYPE_INSTANCE 9

Topology instance file (.instance.yaml).

FILE_TYPE_SIGNAL_DATABASE 10

Signal database file (dbc, ldf, ...).

PlaybackCommand

NameNumberDescription
PLAYBACK_PLAY 0

Play a file.

PLAYBACK_PAUSE 1

Pause playback.

PLAYBACK_SEEK 2

Seek to offset but keep current state.

PLAYBACK_CLOSE 3

Stop and close playback.

RecordingSessionPlaybackMode

NameNumberDescription
PLAYBACK_PLAYING 0

Playing a file.

PLAYBACK_PAUSED 1

Playback is paused.

PLAYBACK_CLOSED 2

Playback in closed.

RecordingSessionService

Handle playback and recordings.

Method NameRequest TypeResponse TypeDescription
ListRecordingFiles FileListingRequest FileListingResponse

List files on server.

PlaybackStatus Empty RecordingSessionPlaybackStatuses stream

Get continuous status of all open recording sessions.

PlaybackOpen RecordingSessionOpenCommand RecordingSessionPlaybackStatus

Prepare playback of a recording session. Always close any opened session after use to avoid resource leaks.

PlaybackPlay RecordingSessionPlayCommand RecordingSessionPlaybackStatus

Start playback of a recording session.

PlaybackPause RecordingSessionPauseCommand RecordingSessionPlaybackStatus

Pause playback of a recording session.

PlaybackSeek RecordingSessionSeekCommand RecordingSessionPlaybackStatus

Seek to offset but keep current mode (playing/paused).

PlaybackClose RecordingSessionCloseCommand RecordingSessionPlaybackStatus

Close playback of a recording session.

PlaybackRepeat RecordingSessionRepeatCommand RecordingSessionPlaybackStatus

Set or remove repeat information.

Methods with HTTP bindings

Method Name Method Pattern Body
ListRecordingFiles POST /v1/ListRecordingFiles/ *
PlaybackStatus POST /v1/RecordingSession/PlaybackStatus *
PlaybackOpen POST /v1/RecordingSession/PlaybackOpen *
PlaybackPlay POST /v1/RecordingSession/PlaybackPlay *
PlaybackPause POST /v1/RecordingSession/PlaybackPause *
PlaybackSeek POST /v1/RecordingSession/PlaybackSeek *
PlaybackClose POST /v1/RecordingSession/PlaybackClose *
PlaybackRepeat POST /v1/RecordingSession/PlaybackRepeat *

diagnostics_api.proto

Top

FieldTypeLabelDescription
clientId base.ClientId

Identifier of subscriber, typically your app identifier. Published signals with same identifier will not trigger callback.

publishSignal base.SignalId

Uplink for intended target This is optional for SubscribeMultiFrame, not setting this will effectively result in sniff_mode, where no control frames are sent. / Uplink for intended target

subscribeSignal base.SignalId

Downlink where response is expected

LinkTimers

FieldTypeLabelDescription
maxResponseTimeout int64

Max milliseconds waiting flow control or single frame before throwing maxRespTimeoutError. Defaults to 1000. Equivavlent to (N_As + N_Bs according to ISO-15765-2) for sender. Equivavlent to (N_Ar + N_Cr according to ISO-15765-2) for receiver.

delayResponse int64

Enables testing of maxResponseTimeout by delaying millieseconds before responding to: received flow control with consecutive frame for sender (N_Cs according to ISO-15765-2). received first frame with flow control for receiver (N_Br according to ISO-15765-2). Defaults to 0.

Payload

FieldTypeLabelDescription
bytes bytes

PublisherConfig

FieldTypeLabelDescription
link Link

payload Payload

linkTimers LinkTimers

LinkTimers currently not supported *

noPadding bool

Used for padding outgoing requests, this is optional. Set to true to remove padding.

SubscriberConfig

FieldTypeLabelDescription
link Link

linkTimers LinkTimers

LinkTimers currently not supported *

rawPayload bool

Specify if the payload should be retured raw or decoded. Setting this to true will provide the raw repsonce without stipped headers and counters. Defaults to false.

noPadding bool

Used for padding outgoing requests, this is optional. Set to true to remove padding.

DiagnosticsService

Method NameRequest TypeResponse TypeDescription
PublishMultiFrame PublisherConfig .base.Empty

CAN MF sending.

SubscribeMultiFrame SubscriberConfig Payload stream

CAN MF Receiving.

Methods with HTTP bindings

Method Name Method Pattern Body
PublishMultiFrame POST /v1/PublishMultiFrame/ *
SubscribeMultiFrame POST /v1/SubscribeMultiFrame/ *

Scalar Value Types

.proto TypeNotesC++JavaPythonGoC#PHPRuby
double double double float float64 double float Float
float float float float float32 float float Float
int32 Uses variable-length encoding. Inefficient for encoding negative numbers – if your field is likely to have negative values, use sint32 instead. int32 int int int32 int integer Bignum or Fixnum (as required)
int64 Uses variable-length encoding. Inefficient for encoding negative numbers – if your field is likely to have negative values, use sint64 instead. int64 long int/long int64 long integer/string Bignum
uint32 Uses variable-length encoding. uint32 int int/long uint32 uint integer Bignum or Fixnum (as required)
uint64 Uses variable-length encoding. uint64 long int/long uint64 ulong integer/string Bignum or Fixnum (as required)
sint32 Uses variable-length encoding. Signed int value. These more efficiently encode negative numbers than regular int32s. int32 int int int32 int integer Bignum or Fixnum (as required)
sint64 Uses variable-length encoding. Signed int value. These more efficiently encode negative numbers than regular int64s. int64 long int/long int64 long integer/string Bignum
fixed32 Always four bytes. More efficient than uint32 if values are often greater than 2^28. uint32 int int uint32 uint integer Bignum or Fixnum (as required)
fixed64 Always eight bytes. More efficient than uint64 if values are often greater than 2^56. uint64 long int/long uint64 ulong integer/string Bignum
sfixed32 Always four bytes. int32 int int int32 int integer Bignum or Fixnum (as required)
sfixed64 Always eight bytes. int64 long int/long int64 long integer/string Bignum
bool bool boolean boolean bool bool boolean TrueClass/FalseClass
string A string must always contain UTF-8 encoded or 7-bit ASCII text. string String str/unicode string string string String (UTF-8)
bytes May contain any arbitrary sequence of bytes. string ByteString str []byte ByteString string String (ASCII-8BIT)